// jp Don't request chunks for which we are currently receiving proxy sources
// jp list that contains chunks that should not be requested during regular downloads because we are currently receiving proxy-sources for it

#include "StdAfx.h"
#include "ThrottledChunkList.h" //jp throttled chunks
#include "OtherFunctions.h" //jp throttled chunks
#include "opcodes.h"
#include "Preferences.h" //jp logging
#include "Log.h"

#define THROTTLED_CHUNK_LIST_SIZE 20

CThrottledChunkList ThrottledChunkList; // global


void CThrottledChunkList::AddToList( ThrottledChunk newelement )
{
if (!ThrottledChunkList.CheckList(newelement, true)) ThrottledChunkList.AddTail(newelement);
return;
}

POSITION CThrottledChunkList::AddTail( ThrottledChunk newelement )
{
	if (thePrefs.GetLogWebCacheEvents())
	AddDebugLogLine( false, _T("Chunk %u added to throttled chunk list, length: %u"),newelement.ChunkNr, GetCount() );

	//if (GetCount() >= THROTTLED_CHUNK_LIST_SIZE)	RemoveHead();
	newelement.timeStamp = ::GetTickCount();
	return CStdThrottledChunkList::AddTail( newelement );
}
bool CThrottledChunkList::CheckList(ThrottledChunk tocompare, bool update)
{	
//	AddDebugLogLine( false, _T("CHECK LIST CALLED"));
	POSITION pos = ThrottledChunkList.GetHeadPosition(), prev_pos = NULL;
	bool found = false;
	uint32 currTick = ::GetTickCount();
	while (prev_pos = pos)
	{
		ThrottledChunk chunk = ThrottledChunkList.GetNext(pos);
		if (currTick - chunk.timeStamp > MIN2MS(10)){
			ThrottledChunkList.RemoveAt(prev_pos);
			continue;
		}
		if (Compare(chunk, tocompare)) {
			found = true;
			if (update)
				chunk.timeStamp = currTick;
		}
	}
	return found;
}

bool CThrottledChunkList::Compare(ThrottledChunk tocompare1, ThrottledChunk tocompare2)
{
//	AddDebugLogLine( false, _T("COMPARE CALLED! Chunk1: %u %s Chunk2: %u %s"),tocompare1.ChunkNr,md4strA( tocompare1.FileID ),tocompare2.ChunkNr,md4strA( tocompare2.FileID ));
	if ((tocompare1.ChunkNr==tocompare2.ChunkNr) && (md4cmp(tocompare1.FileID, tocompare2.FileID)==0)) return true;
	else return false;
}

CThrottledChunkList::CThrottledChunkList(void)
{
}

CThrottledChunkList::~CThrottledChunkList(void)
{
RemoveAll();
}
